# Test writing a edf h5 file
# Faro, Sat 16 Jan 2021 13:58:15 WET  
# Written by Tordar

# Inconsistency in the shape of input parameters is not my fault; 
# that's how variables are stored in the h5 written with Matlab. 

from numpy import *

# Import the function:
from write_edf import *

# Load the mat to get the arrays; 
# simpler parameters are defined explicitely. 
from scipy.io import loadmat
matlab_structure = loadmat('somedata.mat',squeeze_me=True)

DATA = matlab_structure['DATA']
# Strings: 
format_version = 'EDF 1.0'
author         = 'Ricardo Duarte'
institution    = 'University of Algarve'
country_code   = 'PT'
contact        = 'info@siplab.fct.ualg.pt'
comments       = 'Complete dataset'
#data_type      = 'Experimental'
#data_type      = 'Numerical'
#data_type      = ''
data_type     = '@jtvsgfnx'
data_uuid      = 'PT-2020-0615-EXP-0001-0010'
purpose        = 'Testing'
expsetup       = 'CM'
recorder_manufacturer  = 'MarSensing Lda.'
recorder_serial_number = 'SR1-2019'
recorder_model         = 'SR-1'
builtin_hydrophone     = 'Yes'
hydrophone_manufacturer= 'MarSensing Lda.'
hydrophone_serial_number = 'SR1-2019'
hydrophone_model       = 'SR1'
time_duty_on           = '30 minutes'
time_duty_off          = '30 minutes'
frequency_band_definition = '1/3-octave-band/base 2'
calibration_procedure  = 'CPC'
sound_speed_profile_model = 'N/A'
propagation_model         = 'N/A'
# Integers:
start_date       = 20200720 
end_date         = 20201212
date_of_creation = 20201224
hydrophone_sensitivity = [-185]
calibration_frequency_count = [[1]] 
calibration_datetime   = [20190700]
calibration_factor     = [1000]
reference_frequencies  = [100]
frequency_count        = [[2]]
hydrophone_count       = [1]
percentile_count       = [[7]]
time_count             = [[18]]
total_number_of_grid_points = NaN
# Floats: 
depth                  = [10.0]
averaging_time         = [1.0]
percentile_list        = [5.0]
ais_database           = [NaN] 
source_levels          = [NaN] 
bathymetry_database    = [NaN]
temperature_database   = [NaN]
salinity_database      = [NaN] 
numeric_data_calibration = [NaN]
# Arrays:
mlongitude = matrix( DATA['longitude'] )
longitude  = mlongitude[0,0]
mlatitude  = matrix( DATA['latitude' ] )
latitude   = mlatitude[0,0]
mfrequency = matrix( DATA['frequency'] )
frequency  = mfrequency[0,0]
mtime      = matrix( DATA['time'     ] )
time       = mtime[0,0]
mspl_values        = matrix( DATA['spl_values'] )
spl_values         = mspl_values[0,0]
mpercentile_values = matrix( DATA['percentile'] )
percentile_values  = mpercentile_values[0,0]

# Define the data:
data = {"format_version":format_version, "author":author, "institution":institution,"country_code":country_code,
        "contact":contact,"start_date":start_date,"end_date":end_date,"date_of_creation":date_of_creation,
        "purpose":purpose,"data_uuid":data_uuid,"data_type":data_type,"comments":comments,"expsetup":expsetup,
        "recorder_manufacturer":recorder_manufacturer,"recorder_serial_number":recorder_serial_number,
        "recorder_model":recorder_model,"builtin_hydrophone":builtin_hydrophone,
        "hydrophone_manufacturer":hydrophone_manufacturer,"hydrophone_sensitivity":hydrophone_sensitivity,
        "hydrophone_serial_number":hydrophone_serial_number,"hydrophone_model":hydrophone_model,  
        "calibration_frequency_count":calibration_frequency_count,"calibration_datetime":calibration_datetime,
        "calibration_factor":calibration_factor,"calibration_procedure":calibration_procedure,
        "reference_frequencies":reference_frequencies,"ais_database":ais_database,
        "source_levels":source_levels,
        "bathymetry_database":bathymetry_database,"temperature_database":temperature_database,
        "salinity_database":salinity_database,
        "sound_speed_profile_model":sound_speed_profile_model,"propagation_model":propagation_model,
        "numeric_data_calibration":numeric_data_calibration,
        "hydrophone_count":hydrophone_count,
        "total_number_of_grid_points":total_number_of_grid_points,
        "longitude":longitude,"latitude":latitude,"depth":depth,
        "frequency_count":frequency_count,"frequency_band_definition":frequency_band_definition,
        "frequency":frequency,
        "time_duty_on":time_duty_on,"time_duty_off":time_duty_off,"time_count":time_count,
        "time":time,"averaging_time":averaging_time,
        "spl_values":spl_values,
        "percentile_list":percentile_list,"percentile_count":percentile_count,"percentile_values":percentile_values}

# Define the filename:
filename = 'somedata.h5'

# Write the data to the file: 
write_edf(filename,data)
